<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>NMACertChooser: libnma Reference Manual</title>
<meta name="generator" content="DocBook XSL Stylesheets Vsnapshot">
<link rel="home" href="index.html" title="libnma Reference Manual">
<link rel="up" href="api-reference.html" title="libnma API reference">
<link rel="prev" href="NMAWifiDialog.html" title="NMAWifiDialog">
<link rel="next" href="object-tree.html" title="Object Hierarchy">
<meta name="generator" content="GTK-Doc V1.29 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="5"><tr valign="middle">
<td width="100%" align="left" class="shortcuts">
<a href="#" class="shortcut">Top</a><span id="nav_description">  <span class="dim">|</span> 
                  <a href="#NMACertChooser.description" class="shortcut">Description</a></span><span id="nav_hierarchy">  <span class="dim">|</span> 
                  <a href="#NMACertChooser.object-hierarchy" class="shortcut">Object Hierarchy</a></span><span id="nav_properties">  <span class="dim">|</span> 
                  <a href="#NMACertChooser.properties" class="shortcut">Properties</a></span><span id="nav_signals">  <span class="dim">|</span> 
                  <a href="#NMACertChooser.signals" class="shortcut">Signals</a></span>
</td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="16" height="16" border="0" alt="Home"></a></td>
<td><a accesskey="u" href="api-reference.html"><img src="up.png" width="16" height="16" border="0" alt="Up"></a></td>
<td><a accesskey="p" href="NMAWifiDialog.html"><img src="left.png" width="16" height="16" border="0" alt="Prev"></a></td>
<td><a accesskey="n" href="object-tree.html"><img src="right.png" width="16" height="16" border="0" alt="Next"></a></td>
</tr></table>
<div class="refentry">
<a name="NMACertChooser"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="NMACertChooser.top_of_page"></a>NMACertChooser</span></h2>
<p>NMACertChooser</p>
</td>
<td class="gallery_image" valign="top" align="right"></td>
</tr></table></div>
<div class="refsect1">
<a name="NMACertChooser.functions"></a><h2>Functions</h2>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="functions_return">
<col class="functions_name">
</colgroup>
<tbody>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-set-cert" title="nma_cert_chooser_set_cert ()">nma_cert_chooser_set_cert</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-set-cert-uri" title="nma_cert_chooser_set_cert_uri ()">nma_cert_chooser_set_cert_uri</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="returnvalue">gchar</span></a> *
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-get-cert" title="nma_cert_chooser_get_cert ()">nma_cert_chooser_get_cert</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="returnvalue">gchar</span></a> *
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-get-cert-uri" title="nma_cert_chooser_get_cert_uri ()">nma_cert_chooser_get_cert_uri</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-set-cert-password" title="nma_cert_chooser_set_cert_password ()">nma_cert_chooser_set_cert_password</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">const <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="returnvalue">gchar</span></a> *
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-get-cert-password" title="nma_cert_chooser_get_cert_password ()">nma_cert_chooser_get_cert_password</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-set-key" title="nma_cert_chooser_set_key ()">nma_cert_chooser_set_key</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-set-key-uri" title="nma_cert_chooser_set_key_uri ()">nma_cert_chooser_set_key_uri</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="returnvalue">gchar</span></a> *
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-get-key" title="nma_cert_chooser_get_key ()">nma_cert_chooser_get_key</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="returnvalue">gchar</span></a> *
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-get-key-uri" title="nma_cert_chooser_get_key_uri ()">nma_cert_chooser_get_key_uri</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-set-key-password" title="nma_cert_chooser_set_key_password ()">nma_cert_chooser_set_key_password</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">const <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="returnvalue">gchar</span></a> *
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-get-key-password" title="nma_cert_chooser_get_key_password ()">nma_cert_chooser_get_key_password</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">GtkWidget</span> *
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-new" title="nma_cert_chooser_new ()">nma_cert_chooser_new</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-add-to-size-group" title="nma_cert_chooser_add_to_size_group ()">nma_cert_chooser_add_to_size_group</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gboolean"><span class="returnvalue">gboolean</span></a>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-validate" title="nma_cert_chooser_validate ()">nma_cert_chooser_validate</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-setup-cert-password-storage" title="nma_cert_chooser_setup_cert_password_storage ()">nma_cert_chooser_setup_cert_password_storage</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-update-cert-password-storage" title="nma_cert_chooser_update_cert_password_storage ()">nma_cert_chooser_update_cert_password_storage</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSettingSecretFlags"><span class="returnvalue">NMSettingSecretFlags</span></a>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-get-cert-password-flags" title="nma_cert_chooser_get_cert_password_flags ()">nma_cert_chooser_get_cert_password_flags</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-setup-key-password-storage" title="nma_cert_chooser_setup_key_password_storage ()">nma_cert_chooser_setup_key_password_storage</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-update-key-password-storage" title="nma_cert_chooser_update_key_password_storage ()">nma_cert_chooser_update_key_password_storage</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSettingSecretFlags"><span class="returnvalue">NMSettingSecretFlags</span></a>
</td>
<td class="function_name">
<a class="link" href="NMACertChooser.html#nma-cert-chooser-get-key-password-flags" title="nma_cert_chooser_get_key_password_flags ()">nma_cert_chooser_get_key_password_flags</a> <span class="c_punctuation">()</span>
</td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect1">
<a name="NMACertChooser.properties"></a><h2>Properties</h2>
<div class="informaltable"><table class="informaltable" border="0">
<colgroup>
<col width="150px" class="properties_type">
<col width="300px" class="properties_name">
<col width="200px" class="properties_flags">
</colgroup>
<tbody>
<tr>
<td class="property_type"><a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#guint"><span class="type">guint</span></a></td>
<td class="property_name"><a class="link" href="NMACertChooser.html#NMACertChooser--flags" title="The “flags” property">flags</a></td>
<td class="property_flags">Write / Construct Only</td>
</tr>
<tr>
<td class="property_type">
<a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="type">gchar</span></a> *</td>
<td class="property_name"><a class="link" href="NMACertChooser.html#NMACertChooser--title" title="The “title” property">title</a></td>
<td class="property_flags">Write / Construct Only</td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect1">
<a name="NMACertChooser.signals"></a><h2>Signals</h2>
<div class="informaltable"><table class="informaltable" border="0">
<colgroup>
<col width="150px" class="signals_return">
<col width="300px" class="signals_name">
<col width="200px" class="signals_flags">
</colgroup>
<tbody>
<tr>
<td class="signal_type">
<a href="/usr/share/gtk-doc/html/glib/glib-Error-Reporting.html#GError"><span class="returnvalue">GError</span></a>*</td>
<td class="signal_name"><a class="link" href="NMACertChooser.html#NMACertChooser-cert-password-validate" title="The “cert-password-validate” signal">cert-password-validate</a></td>
<td class="signal_flags"><a href="/usr/share/gtk-doc/html/gobject/gobject-Signals.html#G-SIGNAL-RUN-LAST:CAPS">Run Last</a></td>
</tr>
<tr>
<td class="signal_type">
<a href="/usr/share/gtk-doc/html/glib/glib-Error-Reporting.html#GError"><span class="returnvalue">GError</span></a>*</td>
<td class="signal_name"><a class="link" href="NMACertChooser.html#NMACertChooser-cert-validate" title="The “cert-validate” signal">cert-validate</a></td>
<td class="signal_flags"><a href="/usr/share/gtk-doc/html/gobject/gobject-Signals.html#G-SIGNAL-RUN-LAST:CAPS">Run Last</a></td>
</tr>
<tr>
<td class="signal_type"><span class="returnvalue">void</span></td>
<td class="signal_name"><a class="link" href="NMACertChooser.html#NMACertChooser-changed" title="The “changed” signal">changed</a></td>
<td class="signal_flags"><a href="/usr/share/gtk-doc/html/gobject/gobject-Signals.html#G-SIGNAL-NO-RECURSE:CAPS">No Recursion</a></td>
</tr>
<tr>
<td class="signal_type">
<a href="/usr/share/gtk-doc/html/glib/glib-Error-Reporting.html#GError"><span class="returnvalue">GError</span></a>*</td>
<td class="signal_name"><a class="link" href="NMACertChooser.html#NMACertChooser-key-password-validate" title="The “key-password-validate” signal">key-password-validate</a></td>
<td class="signal_flags"><a href="/usr/share/gtk-doc/html/gobject/gobject-Signals.html#G-SIGNAL-RUN-LAST:CAPS">Run Last</a></td>
</tr>
<tr>
<td class="signal_type">
<a href="/usr/share/gtk-doc/html/glib/glib-Error-Reporting.html#GError"><span class="returnvalue">GError</span></a>*</td>
<td class="signal_name"><a class="link" href="NMACertChooser.html#NMACertChooser-key-validate" title="The “key-validate” signal">key-validate</a></td>
<td class="signal_flags"><a href="/usr/share/gtk-doc/html/gobject/gobject-Signals.html#G-SIGNAL-RUN-LAST:CAPS">Run Last</a></td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect1">
<a name="NMACertChooser.other"></a><h2>Types and Values</h2>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="name">
<col class="description">
</colgroup>
<tbody><tr>
<td class="datatype_keyword">enum</td>
<td class="function_name"><a class="link" href="NMACertChooser.html#NMACertChooserFlags" title="enum NMACertChooserFlags">NMACertChooserFlags</a></td>
</tr></tbody>
</table></div>
</div>
<div class="refsect1">
<a name="NMACertChooser.object-hierarchy"></a><h2>Object Hierarchy</h2>
<pre class="screen">    <a href="/usr/share/gtk-doc/html/gobject/gobject-The-Base-Object-Type.html#GObject-struct">GObject</a>
    <span class="lineart">╰──</span> <a href="/usr/share/gtk-doc/html/gobject/gobject-The-Base-Object-Type.html#GInitiallyUnowned">GInitiallyUnowned</a>
        <span class="lineart">╰──</span> GtkWidget
            <span class="lineart">╰──</span> GtkContainer
                <span class="lineart">╰──</span> GtkGrid
                    <span class="lineart">╰──</span> NMACertChooser
</pre>
</div>
<div class="refsect1">
<a name="NMACertChooser.description"></a><h2>Description</h2>
<p>Certificate chooser allows for selection of a certificate or
various schemes optionally accompanied with a key and passwords
or PIN.</p>
<p>The widgets that implement this interface may allow selecting
the certificates from various sources such as files or cryptographic
tokens.</p>
</div>
<div class="refsect1">
<a name="NMACertChooser.functions_details"></a><h2>Functions</h2>
<div class="refsect2">
<a name="nma-cert-chooser-set-cert"></a><h3>nma_cert_chooser_set_cert ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
nma_cert_chooser_set_cert (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                           <em class="parameter"><code>const <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="type">gchar</span></a> *value</code></em>,
                           <em class="parameter"><code><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting8021x.html#NMSetting8021xCKScheme"><span class="type">NMSetting8021xCKScheme</span></a> scheme</code></em>);</pre>
<p>Sets the certificate location for the chooser button.</p>
<div class="refsect3">
<a name="nma-cert-chooser-set-cert.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>value</p></td>
<td class="parameter_description"><p>the path or URI of a certificate</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>scheme</p></td>
<td class="parameter_description"><p>the scheme of the certificate path</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-set-cert-uri"></a><h3>nma_cert_chooser_set_cert_uri ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
nma_cert_chooser_set_cert_uri (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                               <em class="parameter"><code>const <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="type">gchar</span></a> *uri</code></em>);</pre>
<p>Sets the certificate URI for the chooser button.</p>
<div class="refsect3">
<a name="nma-cert-chooser-set-cert-uri.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>uri</p></td>
<td class="parameter_description"><p>the path or URI of a certificate</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-get-cert"></a><h3>nma_cert_chooser_get_cert ()</h3>
<pre class="programlisting"><a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="returnvalue">gchar</span></a> *
nma_cert_chooser_get_cert (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                           <em class="parameter"><code><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting8021x.html#NMSetting8021xCKScheme"><span class="type">NMSetting8021xCKScheme</span></a> *scheme</code></em>);</pre>
<p>Gets the real certificate location from the chooser button along with the scheme.</p>
<div class="refsect3">
<a name="nma-cert-chooser-get-cert.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>scheme</p></td>
<td class="parameter_description"><p>the scheme of the returned certificate path. </p></td>
<td class="parameter_annotations"><span class="annotation">[<acronym title="Parameter for returning results. Default is transfer full."><span class="acronym">out</span></acronym>]</span></td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="nma-cert-chooser-get-cert.returns"></a><h4>Returns</h4>
<p>the certificate path. </p>
<p><span class="annotation">[<acronym title="Free data after the code is done."><span class="acronym">transfer full</span></acronym>][<acronym title="NULL may be passed as the value in, out, in-out; or as a return value."><span class="acronym">nullable</span></acronym>]</span></p>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-get-cert-uri"></a><h3>nma_cert_chooser_get_cert_uri ()</h3>
<pre class="programlisting"><a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="returnvalue">gchar</span></a> *
nma_cert_chooser_get_cert_uri (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>);</pre>
<p>Gets the real certificate URI from the chooser button along with the scheme.</p>
<div class="refsect3">
<a name="nma-cert-chooser-get-cert-uri.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<div class="refsect3">
<a name="nma-cert-chooser-get-cert-uri.returns"></a><h4>Returns</h4>
<p>the certificate URI. </p>
<p><span class="annotation">[<acronym title="Free data after the code is done."><span class="acronym">transfer full</span></acronym>][<acronym title="NULL may be passed as the value in, out, in-out; or as a return value."><span class="acronym">nullable</span></acronym>]</span></p>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-set-cert-password"></a><h3>nma_cert_chooser_set_cert_password ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
nma_cert_chooser_set_cert_password (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                                    <em class="parameter"><code>const <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="type">gchar</span></a> *password</code></em>);</pre>
<p>Sets the password or a PIN that might be required to access the certificate.</p>
<div class="refsect3">
<a name="nma-cert-chooser-set-cert-password.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>password</p></td>
<td class="parameter_description"><p>the certificate PIN or password</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-get-cert-password"></a><h3>nma_cert_chooser_get_cert_password ()</h3>
<pre class="programlisting">const <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="returnvalue">gchar</span></a> *
nma_cert_chooser_get_cert_password (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>);</pre>
<p>Obtains the password or a PIN that was be required to access the certificate.</p>
<div class="refsect3">
<a name="nma-cert-chooser-get-cert-password.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<div class="refsect3">
<a name="nma-cert-chooser-get-cert-password.returns"></a><h4>Returns</h4>
<p> the certificate PIN or password</p>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-set-key"></a><h3>nma_cert_chooser_set_key ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
nma_cert_chooser_set_key (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                          <em class="parameter"><code>const <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="type">gchar</span></a> *value</code></em>,
                          <em class="parameter"><code><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting8021x.html#NMSetting8021xCKScheme"><span class="type">NMSetting8021xCKScheme</span></a> scheme</code></em>);</pre>
<p>Sets the key location for the chooser button.</p>
<div class="refsect3">
<a name="nma-cert-chooser-set-key.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>value</p></td>
<td class="parameter_description"><p>the path or URI of a key</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>scheme</p></td>
<td class="parameter_description"><p>the scheme of the key path</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-set-key-uri"></a><h3>nma_cert_chooser_set_key_uri ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
nma_cert_chooser_set_key_uri (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                              <em class="parameter"><code>const <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="type">gchar</span></a> *uri</code></em>);</pre>
<p>Sets the key URI for the chooser button.</p>
<div class="refsect3">
<a name="nma-cert-chooser-set-key-uri.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>uri</p></td>
<td class="parameter_description"><p>the URI of a key</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-get-key"></a><h3>nma_cert_chooser_get_key ()</h3>
<pre class="programlisting"><a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="returnvalue">gchar</span></a> *
nma_cert_chooser_get_key (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                          <em class="parameter"><code><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting8021x.html#NMSetting8021xCKScheme"><span class="type">NMSetting8021xCKScheme</span></a> *scheme</code></em>);</pre>
<p>Gets the real key location from the chooser button along with the scheme.</p>
<div class="refsect3">
<a name="nma-cert-chooser-get-key.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>scheme</p></td>
<td class="parameter_description"><p>the scheme of the returned key path. </p></td>
<td class="parameter_annotations"><span class="annotation">[<acronym title="Parameter for returning results. Default is transfer full."><span class="acronym">out</span></acronym>]</span></td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="nma-cert-chooser-get-key.returns"></a><h4>Returns</h4>
<p>the key path. </p>
<p><span class="annotation">[<acronym title="Free data after the code is done."><span class="acronym">transfer full</span></acronym>][<acronym title="NULL may be passed as the value in, out, in-out; or as a return value."><span class="acronym">nullable</span></acronym>]</span></p>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-get-key-uri"></a><h3>nma_cert_chooser_get_key_uri ()</h3>
<pre class="programlisting"><a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="returnvalue">gchar</span></a> *
nma_cert_chooser_get_key_uri (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>);</pre>
<p>Gets the real key URI from the chooser button along with the scheme.</p>
<div class="refsect3">
<a name="nma-cert-chooser-get-key-uri.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<div class="refsect3">
<a name="nma-cert-chooser-get-key-uri.returns"></a><h4>Returns</h4>
<p>the key URI. </p>
<p><span class="annotation">[<acronym title="Free data after the code is done."><span class="acronym">transfer full</span></acronym>][<acronym title="NULL may be passed as the value in, out, in-out; or as a return value."><span class="acronym">nullable</span></acronym>]</span></p>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-set-key-password"></a><h3>nma_cert_chooser_set_key_password ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
nma_cert_chooser_set_key_password (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                                   <em class="parameter"><code>const <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="type">gchar</span></a> *password</code></em>);</pre>
<p>Sets the password or a PIN that might be required to access the key.</p>
<div class="refsect3">
<a name="nma-cert-chooser-set-key-password.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>password</p></td>
<td class="parameter_description"><p>the key PIN or password</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-get-key-password"></a><h3>nma_cert_chooser_get_key_password ()</h3>
<pre class="programlisting">const <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="returnvalue">gchar</span></a> *
nma_cert_chooser_get_key_password (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>);</pre>
<p>Obtains the password or a PIN that was be required to access the key.</p>
<div class="refsect3">
<a name="nma-cert-chooser-get-key-password.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<div class="refsect3">
<a name="nma-cert-chooser-get-key-password.returns"></a><h4>Returns</h4>
<p> the key PIN or password</p>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-new"></a><h3>nma_cert_chooser_new ()</h3>
<pre class="programlisting"><span class="returnvalue">GtkWidget</span> *
nma_cert_chooser_new (<em class="parameter"><code>const <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="type">gchar</span></a> *title</code></em>,
                      <em class="parameter"><code><a class="link" href="NMACertChooser.html#NMACertChooserFlags" title="enum NMACertChooserFlags"><span class="type">NMACertChooserFlags</span></a> flags</code></em>);</pre>
<p>Constructs the button that is capable of selecting a certificate
and a key.</p>
<div class="refsect3">
<a name="nma-cert-chooser-new.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>title</p></td>
<td class="parameter_description"><p>title of the certificate chooser dialog</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>flags</p></td>
<td class="parameter_description"><p>the flags that configure the capabilities of the button</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="nma-cert-chooser-new.returns"></a><h4>Returns</h4>
<p>the certificate chooser button instance. </p>
<p><span class="annotation">[<acronym title="Free data after the code is done."><span class="acronym">transfer full</span></acronym>]</span></p>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-add-to-size-group"></a><h3>nma_cert_chooser_add_to_size_group ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
nma_cert_chooser_add_to_size_group (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                                    <em class="parameter"><code><span class="type">GtkSizeGroup</span> *group</code></em>);</pre>
<p>Adds the labels to the specified size group so that they are aligned
nicely with other entries in a form.</p>
<p>It is expected that the NMACertChooser is a GtkGrid with two columns
with the labels in the first one.</p>
<div class="refsect3">
<a name="nma-cert-chooser-add-to-size-group.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>group</p></td>
<td class="parameter_description"><p>a size group</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-validate"></a><h3>nma_cert_chooser_validate ()</h3>
<pre class="programlisting"><a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gboolean"><span class="returnvalue">gboolean</span></a>
nma_cert_chooser_validate (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                           <em class="parameter"><code><a href="/usr/share/gtk-doc/html/glib/glib-Error-Reporting.html#GError"><span class="type">GError</span></a> **error</code></em>);</pre>
<p>Validates whether the chosen values make sense. The users can do further
validation by subscribing to the "*-changed" signals and returning an
error themselves.</p>
<div class="refsect3">
<a name="nma-cert-chooser-validate.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>error</p></td>
<td class="parameter_description"><p>error return location</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="nma-cert-chooser-validate.returns"></a><h4>Returns</h4>
<p> <a href="/usr/share/gtk-doc/html/glib/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if validation passes, <a href="/usr/share/gtk-doc/html/glib/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> otherwise</p>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-setup-cert-password-storage"></a><h3>nma_cert_chooser_setup_cert_password_storage ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
nma_cert_chooser_setup_cert_password_storage
                               (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                                <em class="parameter"><code><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSettingSecretFlags"><span class="type">NMSettingSecretFlags</span></a> initial_flags</code></em>,
                                <em class="parameter"><code><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSetting-struct"><span class="type">NMSetting</span></a> *setting</code></em>,
                                <em class="parameter"><code>const <span class="type">char</span> *password_flags_name</code></em>,
                                <em class="parameter"><code><a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gboolean"><span class="type">gboolean</span></a> with_not_required</code></em>,
                                <em class="parameter"><code><a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gboolean"><span class="type">gboolean</span></a> ask_mode</code></em>);</pre>
<p>This method basically calls <a class="link" href="libnma-nma-ui-utils.html#nma-utils-setup-password-storage" title="nma_utils_setup_password_storage ()"><code class="function">nma_utils_setup_password_storage()</code></a>
on the certificate password entry, in case one is present.</p>
<div class="refsect3">
<a name="nma-cert-chooser-setup-cert-password-storage.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>initial_flags</p></td>
<td class="parameter_description"><p>initial secret flags to setup password menu from</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>setting</p></td>
<td class="parameter_description"><p><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSetting-struct"><span class="type">NMSetting</span></a> containing the password, or NULL</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>password_flags_name</p></td>
<td class="parameter_description"><p>name of the secret flags (like psk-flags), or NULL</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>with_not_required</p></td>
<td class="parameter_description"><p>whether to include "Not required" menu item</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>ask_mode</p></td>
<td class="parameter_description"><p><a href="/usr/share/gtk-doc/html/glib/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if the entry is shown in ASK mode</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-update-cert-password-storage"></a><h3>nma_cert_chooser_update_cert_password_storage ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
nma_cert_chooser_update_cert_password_storage
                               (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                                <em class="parameter"><code><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSettingSecretFlags"><span class="type">NMSettingSecretFlags</span></a> secret_flags</code></em>,
                                <em class="parameter"><code><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSetting-struct"><span class="type">NMSetting</span></a> *setting</code></em>,
                                <em class="parameter"><code>const <span class="type">char</span> *password_flags_name</code></em>);</pre>
<p>This method basically calls <a class="link" href="libnma-nma-ui-utils.html#nma-utils-update-password-storage" title="nma_utils_update_password_storage ()"><code class="function">nma_utils_update_password_storage()</code></a>
on the certificate password entry, in case one is present.</p>
<div class="refsect3">
<a name="nma-cert-chooser-update-cert-password-storage.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>secret_flags</p></td>
<td class="parameter_description"><p>secret flags to set</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>setting</p></td>
<td class="parameter_description"><p><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSetting-struct"><span class="type">NMSetting</span></a> containing the password, or NULL</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>password_flags_name</p></td>
<td class="parameter_description"><p>name of the secret flags (like psk-flags), or NULL</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-get-cert-password-flags"></a><h3>nma_cert_chooser_get_cert_password_flags ()</h3>
<pre class="programlisting"><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSettingSecretFlags"><span class="returnvalue">NMSettingSecretFlags</span></a>
nma_cert_chooser_get_cert_password_flags
                               (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>);</pre>
<p>Returns secret flags corresponding to the certificate password
if one is present. The chooser would typically call into
<a class="link" href="libnma-nma-ui-utils.html#nma-utils-menu-to-secret-flags" title="nma_utils_menu_to_secret_flags ()"><code class="function">nma_utils_menu_to_secret_flags()</code></a> for the certificate password
entry.</p>
<div class="refsect3">
<a name="nma-cert-chooser-get-cert-password-flags.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<div class="refsect3">
<a name="nma-cert-chooser-get-cert-password-flags.returns"></a><h4>Returns</h4>
<p> secret flags corresponding to the certificate password</p>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-setup-key-password-storage"></a><h3>nma_cert_chooser_setup_key_password_storage ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
nma_cert_chooser_setup_key_password_storage
                               (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                                <em class="parameter"><code><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSettingSecretFlags"><span class="type">NMSettingSecretFlags</span></a> initial_flags</code></em>,
                                <em class="parameter"><code><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSetting-struct"><span class="type">NMSetting</span></a> *setting</code></em>,
                                <em class="parameter"><code>const <span class="type">char</span> *password_flags_name</code></em>,
                                <em class="parameter"><code><a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gboolean"><span class="type">gboolean</span></a> with_not_required</code></em>,
                                <em class="parameter"><code><a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gboolean"><span class="type">gboolean</span></a> ask_mode</code></em>);</pre>
<p>This method basically calls <a class="link" href="libnma-nma-ui-utils.html#nma-utils-setup-password-storage" title="nma_utils_setup_password_storage ()"><code class="function">nma_utils_setup_password_storage()</code></a>
on the key password entry, in case one is present.</p>
<div class="refsect3">
<a name="nma-cert-chooser-setup-key-password-storage.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>initial_flags</p></td>
<td class="parameter_description"><p>initial secret flags to setup password menu from</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>setting</p></td>
<td class="parameter_description"><p><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSetting-struct"><span class="type">NMSetting</span></a> containing the password, or NULL</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>password_flags_name</p></td>
<td class="parameter_description"><p>name of the secret flags (like psk-flags), or NULL</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>with_not_required</p></td>
<td class="parameter_description"><p>whether to include "Not required" menu item</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>ask_mode</p></td>
<td class="parameter_description"><p><a href="/usr/share/gtk-doc/html/glib/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if the entry is shown in ASK mode</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-update-key-password-storage"></a><h3>nma_cert_chooser_update_key_password_storage ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
nma_cert_chooser_update_key_password_storage
                               (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>,
                                <em class="parameter"><code><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSettingSecretFlags"><span class="type">NMSettingSecretFlags</span></a> secret_flags</code></em>,
                                <em class="parameter"><code><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSetting-struct"><span class="type">NMSetting</span></a> *setting</code></em>,
                                <em class="parameter"><code>const <span class="type">char</span> *password_flags_name</code></em>);</pre>
<p>This method basically calls <a class="link" href="libnma-nma-ui-utils.html#nma-utils-update-password-storage" title="nma_utils_update_password_storage ()"><code class="function">nma_utils_update_password_storage()</code></a>
on the key password entry, in case one is present.</p>
<div class="refsect3">
<a name="nma-cert-chooser-update-key-password-storage.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>secret_flags</p></td>
<td class="parameter_description"><p>secret flags to set</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>setting</p></td>
<td class="parameter_description"><p><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSetting-struct"><span class="type">NMSetting</span></a> containing the password, or NULL</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>password_flags_name</p></td>
<td class="parameter_description"><p>name of the secret flags (like psk-flags), or NULL</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="nma-cert-chooser-get-key-password-flags"></a><h3>nma_cert_chooser_get_key_password_flags ()</h3>
<pre class="programlisting"><a href="/usr/share/gtk-doc/html/libnm-util/NMSetting.html#NMSettingSecretFlags"><span class="returnvalue">NMSettingSecretFlags</span></a>
nma_cert_chooser_get_key_password_flags
                               (<em class="parameter"><code><a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *cert_chooser</code></em>);</pre>
<p>Returns secret flags corresponding to the key password
if one is present. The chooser would typically call into
<a class="link" href="libnma-nma-ui-utils.html#nma-utils-menu-to-secret-flags" title="nma_utils_menu_to_secret_flags ()"><code class="function">nma_utils_menu_to_secret_flags()</code></a> for the key password
entry.</p>
<div class="refsect3">
<a name="nma-cert-chooser-get-key-password-flags.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>cert_chooser</p></td>
<td class="parameter_description"><p>certificate chooser button instance</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<div class="refsect3">
<a name="nma-cert-chooser-get-key-password-flags.returns"></a><h4>Returns</h4>
<p> secret flags corresponding to the key password</p>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
</div>
<div class="refsect1">
<a name="NMACertChooser.other_details"></a><h2>Types and Values</h2>
<div class="refsect2">
<a name="NMACertChooserFlags"></a><h3>enum NMACertChooserFlags</h3>
<p>Flags that controls what is the certificate chooser button able to pick.
Currently only local files are supported, but might be extended to use URIs,
such as PKCS#11 certificate URIs in future as well.</p>
<div class="refsect3">
<a name="NMACertChooserFlags.members"></a><h4>Members</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="300px" class="enum_members_name">
<col class="enum_members_description">
<col width="200px" class="enum_members_annotations">
</colgroup>
<tbody>
<tr>
<td class="enum_member_name"><p><a name="NMA-CERT-CHOOSER-FLAG-NONE:CAPS"></a>NMA_CERT_CHOOSER_FLAG_NONE</p></td>
<td class="enum_member_description">
<p>No flags</p>
</td>
<td class="enum_member_annotations"> </td>
</tr>
<tr>
<td class="enum_member_name"><p><a name="NMA-CERT-CHOOSER-FLAG-CERT:CAPS"></a>NMA_CERT_CHOOSER_FLAG_CERT</p></td>
<td class="enum_member_description">
<p>Only pick a certificate, not a key</p>
</td>
<td class="enum_member_annotations"> </td>
</tr>
<tr>
<td class="enum_member_name"><p><a name="NMA-CERT-CHOOSER-FLAG-PASSWORDS:CAPS"></a>NMA_CERT_CHOOSER_FLAG_PASSWORDS</p></td>
<td class="enum_member_description">
<p>Hide all controls but the secrets entries</p>
</td>
<td class="enum_member_annotations"> </td>
</tr>
<tr>
<td class="enum_member_name"><p><a name="NMA-CERT-CHOOSER-FLAG-PEM:CAPS"></a>NMA_CERT_CHOOSER_FLAG_PEM</p></td>
<td class="enum_member_description">
<p>Ensure the chooser only selects regular PEM files</p>
</td>
<td class="enum_member_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
</div>
<div class="refsect1">
<a name="NMACertChooser.property-details"></a><h2>Property Details</h2>
<div class="refsect2">
<a name="NMACertChooser--flags"></a><h3>The <code class="literal">“flags”</code> property</h3>
<pre class="programlisting">  “flags”                    <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#guint"><span class="type">guint</span></a></pre>
<p>Certificate Chooser Flags.</p>
<p>Flags: Write / Construct Only</p>
<p>Allowed values: &lt;= 7</p>
<p>Default value: 0</p>
</div>
<hr>
<div class="refsect2">
<a name="NMACertChooser--title"></a><h3>The <code class="literal">“title”</code> property</h3>
<pre class="programlisting">  “title”                    <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gchar"><span class="type">gchar</span></a> *</pre>
<p>Certificate Chooser Title.</p>
<p>Flags: Write / Construct Only</p>
<p>Default value: NULL</p>
</div>
</div>
<div class="refsect1">
<a name="NMACertChooser.signal-details"></a><h2>Signal Details</h2>
<div class="refsect2">
<a name="NMACertChooser-cert-password-validate"></a><h3>The <code class="literal">“cert-password-validate”</code> signal</h3>
<pre class="programlisting"><a href="/usr/share/gtk-doc/html/glib/glib-Error-Reporting.html#GError"><span class="returnvalue">GError</span></a>*
user_function (<a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *nmacertchooser,
               <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gpointer"><span class="type">gpointer</span></a>        user_data)</pre>
<p>Emitted when the certificate password needs validation. The handlers
can indicate that the password is invalid by returning an error, which blocks further
signal processing and causes a call to <a class="link" href="NMACertChooser.html#nma-cert-chooser-validate" title="nma_cert_chooser_validate ()"><code class="function">nma_cert_chooser_validate()</code></a>
to fail.</p>
<div class="refsect3">
<a name="NMACertChooser-cert-password-validate.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>user_data</p></td>
<td class="parameter_description"><p>user data set when the signal handler was connected.</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<p>Flags: <a href="/usr/share/gtk-doc/html/gobject/gobject-Signals.html#G-SIGNAL-RUN-LAST:CAPS">Run Last</a></p>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="NMACertChooser-cert-validate"></a><h3>The <code class="literal">“cert-validate”</code> signal</h3>
<pre class="programlisting"><a href="/usr/share/gtk-doc/html/glib/glib-Error-Reporting.html#GError"><span class="returnvalue">GError</span></a>*
user_function (<a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *nmacertchooser,
               <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gpointer"><span class="type">gpointer</span></a>        user_data)</pre>
<p>Emitted when the certificate needs validation. The handlers can indicate that
the certificate is invalid by returning an error, which blocks further
signal processing and causes a call to <a class="link" href="NMACertChooser.html#nma-cert-chooser-validate" title="nma_cert_chooser_validate ()"><code class="function">nma_cert_chooser_validate()</code></a>
to fail.</p>
<div class="refsect3">
<a name="NMACertChooser-cert-validate.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>user_data</p></td>
<td class="parameter_description"><p>user data set when the signal handler was connected.</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<p>Flags: <a href="/usr/share/gtk-doc/html/gobject/gobject-Signals.html#G-SIGNAL-RUN-LAST:CAPS">Run Last</a></p>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="NMACertChooser-changed"></a><h3>The <code class="literal">“changed”</code> signal</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
user_function (<a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *nmacertchooser,
               <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gpointer"><span class="type">gpointer</span></a>        user_data)</pre>
<p>Emitted when anything changes in the certificate chooser, be it a certificate,
a key or associated passwords.</p>
<div class="refsect3">
<a name="NMACertChooser-changed.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>user_data</p></td>
<td class="parameter_description"><p>user data set when the signal handler was connected.</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<p>Flags: <a href="/usr/share/gtk-doc/html/gobject/gobject-Signals.html#G-SIGNAL-NO-RECURSE:CAPS">No Recursion</a></p>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="NMACertChooser-key-password-validate"></a><h3>The <code class="literal">“key-password-validate”</code> signal</h3>
<pre class="programlisting"><a href="/usr/share/gtk-doc/html/glib/glib-Error-Reporting.html#GError"><span class="returnvalue">GError</span></a>*
user_function (<a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *nmacertchooser,
               <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gpointer"><span class="type">gpointer</span></a>        user_data)</pre>
<p>Emitted when the key password needs validation. The handlers can indicate
that the password is invalid by returning an error, which blocks further
signal processing and causes a call to <a class="link" href="NMACertChooser.html#nma-cert-chooser-validate" title="nma_cert_chooser_validate ()"><code class="function">nma_cert_chooser_validate()</code></a>
to fail.</p>
<div class="refsect3">
<a name="NMACertChooser-key-password-validate.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>user_data</p></td>
<td class="parameter_description"><p>user data set when the signal handler was connected.</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<p>Flags: <a href="/usr/share/gtk-doc/html/gobject/gobject-Signals.html#G-SIGNAL-RUN-LAST:CAPS">Run Last</a></p>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
<hr>
<div class="refsect2">
<a name="NMACertChooser-key-validate"></a><h3>The <code class="literal">“key-validate”</code> signal</h3>
<pre class="programlisting"><a href="/usr/share/gtk-doc/html/glib/glib-Error-Reporting.html#GError"><span class="returnvalue">GError</span></a>*
user_function (<a class="link" href="NMACertChooser.html" title="NMACertChooser"><span class="type">NMACertChooser</span></a> *nmacertchooser,
               <a href="/usr/share/gtk-doc/html/glib/glib-Basic-Types.html#gpointer"><span class="type">gpointer</span></a>        user_data)</pre>
<p>Emitted when the key needs validation. The handlers can indicate that
the key is invalid by returning an error, which blocks further
signal processing and causes a call to <a class="link" href="NMACertChooser.html#nma-cert-chooser-validate" title="nma_cert_chooser_validate ()"><code class="function">nma_cert_chooser_validate()</code></a>
to fail.</p>
<div class="refsect3">
<a name="NMACertChooser-key-validate.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>user_data</p></td>
<td class="parameter_description"><p>user data set when the signal handler was connected.</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<p>Flags: <a href="/usr/share/gtk-doc/html/gobject/gobject-Signals.html#G-SIGNAL-RUN-LAST:CAPS">Run Last</a></p>
<p class="since">Since: <a class="link" href="api-index-1.8.0.html" title="Index of API available in version 1.8.0">1.8.0</a></p>
</div>
</div>
</div>
<div class="footer">
<hr>Generated by GTK-Doc V1.29</div>
</body>
</html>